# coding: utf-8

"""
    HiddenLayer-API

    HiddenLayer-API

    The version of the OpenAPI document: 1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from hiddenlayer.sdk.rest.models.location_relationship import LocationRelationship
from hiddenlayer.sdk.rest.models.logical_location import LogicalLocation
from hiddenlayer.sdk.rest.models.message import Message
from hiddenlayer.sdk.rest.models.physical_location import PhysicalLocation
from hiddenlayer.sdk.rest.models.property_bag import PropertyBag
from hiddenlayer.sdk.rest.models.region import Region
from typing import Optional, Set
from typing_extensions import Self

class Location(BaseModel):
    """
    A location within a programming artifact.
    """ # noqa: E501
    id: Optional[Annotated[int, Field(strict=True, ge=-1)]] = Field(default=-1, description="Value that distinguishes this location from all other locations within a single result object.")
    physical_location: Optional[PhysicalLocation] = Field(default=None, alias="physicalLocation")
    logical_locations: Optional[Annotated[List[LogicalLocation], Field(min_length=0)]] = Field(default=None, description="The logical locations associated with the result.", alias="logicalLocations")
    message: Optional[Message] = None
    annotations: Optional[Annotated[List[Region], Field(min_length=0)]] = Field(default=None, description="A set of regions relevant to the location.")
    relationships: Optional[Annotated[List[LocationRelationship], Field(min_length=0)]] = Field(default=None, description="An array of objects that describe relationships between this location and others.")
    properties: Optional[PropertyBag] = None
    __properties: ClassVar[List[str]] = ["id", "physicalLocation", "logicalLocations", "message", "annotations", "relationships", "properties"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Location from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of physical_location
        if self.physical_location:
            _dict['physicalLocation'] = self.physical_location.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in logical_locations (list)
        _items = []
        if self.logical_locations:
            for _item in self.logical_locations:
                if _item:
                    _items.append(_item.to_dict())
            _dict['logicalLocations'] = _items
        # override the default output from pydantic by calling `to_dict()` of message
        if self.message:
            _dict['message'] = self.message.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in annotations (list)
        _items = []
        if self.annotations:
            for _item in self.annotations:
                if _item:
                    _items.append(_item.to_dict())
            _dict['annotations'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in relationships (list)
        _items = []
        if self.relationships:
            for _item in self.relationships:
                if _item:
                    _items.append(_item.to_dict())
            _dict['relationships'] = _items
        # override the default output from pydantic by calling `to_dict()` of properties
        if self.properties:
            _dict['properties'] = self.properties.to_dict()
        # set to None if physical_location (nullable) is None
        # and model_fields_set contains the field
        if self.physical_location is None and "physical_location" in self.model_fields_set:
            _dict['physicalLocation'] = None

        # set to None if message (nullable) is None
        # and model_fields_set contains the field
        if self.message is None and "message" in self.model_fields_set:
            _dict['message'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Location from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id") if obj.get("id") is not None else -1,
            "physicalLocation": PhysicalLocation.from_dict(obj["physicalLocation"]) if obj.get("physicalLocation") is not None else None,
            "logicalLocations": [LogicalLocation.from_dict(_item) for _item in obj["logicalLocations"]] if obj.get("logicalLocations") is not None else None,
            "message": Message.from_dict(obj["message"]) if obj.get("message") is not None else None,
            "annotations": [Region.from_dict(_item) for _item in obj["annotations"]] if obj.get("annotations") is not None else None,
            "relationships": [LocationRelationship.from_dict(_item) for _item in obj["relationships"]] if obj.get("relationships") is not None else None,
            "properties": PropertyBag.from_dict(obj["properties"]) if obj.get("properties") is not None else None
        })
        return _obj


