# coding: utf-8

"""
    HiddenLayer-API

    HiddenLayer-API

    The version of the OpenAPI document: 1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from hiddenlayer.sdk.rest.models.file_scan_report_v3 import FileScanReportV3
from hiddenlayer.sdk.rest.models.model_inventory_info import ModelInventoryInfo
from typing import Optional, Set
from typing_extensions import Self

class ScanReportV3(BaseModel):
    """
    ScanReportV3
    """ # noqa: E501
    file_count: StrictInt = Field(description="number of files scanned")
    files_with_detections_count: StrictInt = Field(description="number of files with detections found")
    detection_count: StrictInt = Field(description="number of detections found")
    detection_categories: Optional[List[StrictStr]] = Field(default=None, description="list of detection categories found")
    inventory: ModelInventoryInfo
    version: StrictStr = Field(description="scanner version")
    scan_id: StrictStr = Field(description="unique identifier for the scan")
    start_time: datetime = Field(description="time the scan started")
    end_time: Optional[datetime] = Field(default=None, description="time the scan ended")
    status: StrictStr = Field(description="status of the scan")
    severity: Optional[StrictStr] = Field(default=None, description="detection severity")
    file_results: Optional[List[FileScanReportV3]] = None
    __properties: ClassVar[List[str]] = ["file_count", "files_with_detections_count", "detection_count", "detection_categories", "inventory", "version", "scan_id", "start_time", "end_time", "status", "severity", "file_results"]

    @field_validator('status')
    def status_validate_enum(cls, value):
        """Validates the enum"""
        if value not in set(['pending', 'running', 'done', 'failed', 'canceled']):
            raise ValueError("must be one of enum values ('pending', 'running', 'done', 'failed', 'canceled')")
        return value

    @field_validator('severity')
    def severity_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['low', 'medium', 'high', 'critical', 'safe', 'unknown']):
            raise ValueError("must be one of enum values ('low', 'medium', 'high', 'critical', 'safe', 'unknown')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ScanReportV3 from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of inventory
        if self.inventory:
            _dict['inventory'] = self.inventory.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in file_results (list)
        _items = []
        if self.file_results:
            for _item in self.file_results:
                if _item:
                    _items.append(_item.to_dict())
            _dict['file_results'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ScanReportV3 from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "file_count": obj.get("file_count"),
            "files_with_detections_count": obj.get("files_with_detections_count"),
            "detection_count": obj.get("detection_count"),
            "detection_categories": obj.get("detection_categories"),
            "inventory": ModelInventoryInfo.from_dict(obj["inventory"]) if obj.get("inventory") is not None else None,
            "version": obj.get("version"),
            "scan_id": obj.get("scan_id"),
            "start_time": obj.get("start_time"),
            "end_time": obj.get("end_time"),
            "status": obj.get("status"),
            "severity": obj.get("severity"),
            "file_results": [FileScanReportV3.from_dict(_item) for _item in obj["file_results"]] if obj.get("file_results") is not None else None
        })
        return _obj


